#pragma once

typedef unsigned collision_T;

enum _collisions {
	COLLISION_SOLID,
	COLLISION_HAZARD,
	COLLISION_FLOOR,

	COLLISION_LENGTH // no. of checked inputs
};

#define collision_solid(a)   (1 & (a) >> COLLISION_SOLID)
#define collision_hazard(a)  (1 & (a) >> COLLISION_HAZARD)
#define collision_floor(a)   (1 & (a) >> COLLISION_FLOOR)
