#include "entity.h"
#include "loader.h"
#include "main.h"

void *walker_new(struct entities *entities);
int walker_property(void *const restrict entity, char const *const restrict property, char const *const restrict value);
void *flier_new(struct entities *entities);
int flier_property(void *const restrict entity, char const *const restrict property, char const *const restrict value);

void *warp_new(struct entities *entities);
int warp_property(void *const restrict entity, char const *const restrict property, char const *const restrict value);

void funs_init(void) {
	res_push_fun(walker_new, walker_property, "walker");
	res_push_fun(flier_new, flier_property, "flier");
	res_push_fun(warp_new, warp_property, "warp");
}
